diff --git a/Resources/installer/sql/demo_data.sql b/Resources/installer/sql/demo_data.sql
index 4c33867..3e4afd4 100644
--- a/Resources/installer/sql/demo_data.sql
+++ b/Resources/installer/sql/demo_data.sql
@@ -1165,16 +1165,6 @@ INSERT INTO `ezpolicy` VALUES ('create',367,'content',0,4);
 INSERT INTO `ezpolicy` VALUES ('edit',368,'content',0,4);
 INSERT INTO `ezpolicy` VALUES ('selfedit',369,'user',0,4);
 INSERT INTO `ezpolicy` VALUES ('use',370,'notification',0,4);
-INSERT INTO `ezpolicy` VALUES ('create',371,'content',0,5);
-INSERT INTO `ezpolicy` VALUES ('create',372,'content',0,5);
-INSERT INTO `ezpolicy` VALUES ('create',373,'content',0,5);
-INSERT INTO `ezpolicy` VALUES ('edit',374,'content',0,5);
-INSERT INTO `ezpolicy` VALUES ('selfedit',375,'user',0,5);
-INSERT INTO `ezpolicy` VALUES ('use',376,'notification',0,5);
-INSERT INTO `ezpolicy` VALUES ('password',377,'user',0,5);
-INSERT INTO `ezpolicy` VALUES ('call',378,'ezjscore',0,5);
-INSERT INTO `ezpolicy` VALUES ('read',379,'content',0,5);
-INSERT INTO `ezpolicy` VALUES ('read',380,'content',0,6);
 INSERT INTO `ezpolicy` VALUES ('login',541,'user',0,3);
 INSERT INTO `ezpolicy` VALUES ('*',542,'ezoe',0,3);
 INSERT INTO `ezpolicy` VALUES ('*',543,'ezoe',0,3);
@@ -1219,22 +1209,6 @@ INSERT INTO `ezpolicy_limitation` VALUES (285,'ParentClass',367);
 INSERT INTO `ezpolicy_limitation` VALUES (286,'Class',368);
 INSERT INTO `ezpolicy_limitation` VALUES (287,'Section',368);
 INSERT INTO `ezpolicy_limitation` VALUES (288,'Owner',368);
-INSERT INTO `ezpolicy_limitation` VALUES (289,'Class',371);
-INSERT INTO `ezpolicy_limitation` VALUES (290,'Section',371);
-INSERT INTO `ezpolicy_limitation` VALUES (291,'ParentClass',371);
-INSERT INTO `ezpolicy_limitation` VALUES (292,'Class',372);
-INSERT INTO `ezpolicy_limitation` VALUES (293,'Section',372);
-INSERT INTO `ezpolicy_limitation` VALUES (294,'ParentClass',372);
-INSERT INTO `ezpolicy_limitation` VALUES (295,'Class',373);
-INSERT INTO `ezpolicy_limitation` VALUES (296,'Section',373);
-INSERT INTO `ezpolicy_limitation` VALUES (297,'ParentClass',373);
-INSERT INTO `ezpolicy_limitation` VALUES (298,'Class',374);
-INSERT INTO `ezpolicy_limitation` VALUES (299,'Section',374);
-INSERT INTO `ezpolicy_limitation` VALUES (300,'Owner',374);
-INSERT INTO `ezpolicy_limitation` VALUES (301,'Owner',379);
-INSERT INTO `ezpolicy_limitation` VALUES (302,'Class',379);
-INSERT INTO `ezpolicy_limitation` VALUES (303,'Class',380);
-INSERT INTO `ezpolicy_limitation` VALUES (304,'Section',380);
 INSERT INTO `ezpolicy_limitation` VALUES (393,'Class',544);
 INSERT INTO `ezpolicy_limitation` VALUES (394,'ParentClass',544);
 INSERT INTO `ezpolicy_limitation` VALUES (395,'Class',545);
@@ -1272,28 +1246,9 @@ INSERT INTO `ezpolicy_limitation_value` VALUES (559,286,'31');
 INSERT INTO `ezpolicy_limitation_value` VALUES (560,286,'32');
 INSERT INTO `ezpolicy_limitation_value` VALUES (561,287,'6');
 INSERT INTO `ezpolicy_limitation_value` VALUES (562,288,'1');
-INSERT INTO `ezpolicy_limitation_value` VALUES (563,289,'31');
-INSERT INTO `ezpolicy_limitation_value` VALUES (564,290,'1');
-INSERT INTO `ezpolicy_limitation_value` VALUES (565,291,'30');
-INSERT INTO `ezpolicy_limitation_value` VALUES (566,292,'32');
-INSERT INTO `ezpolicy_limitation_value` VALUES (567,293,'1');
-INSERT INTO `ezpolicy_limitation_value` VALUES (568,294,'31');
-INSERT INTO `ezpolicy_limitation_value` VALUES (569,295,'13');
-INSERT INTO `ezpolicy_limitation_value` VALUES (570,296,'1');
-INSERT INTO `ezpolicy_limitation_value` VALUES (571,297,'16');
-INSERT INTO `ezpolicy_limitation_value` VALUES (572,297,'18');
-INSERT INTO `ezpolicy_limitation_value` VALUES (573,298,'13');
-INSERT INTO `ezpolicy_limitation_value` VALUES (574,298,'31');
-INSERT INTO `ezpolicy_limitation_value` VALUES (575,298,'32');
-INSERT INTO `ezpolicy_limitation_value` VALUES (576,299,'1');
-INSERT INTO `ezpolicy_limitation_value` VALUES (577,300,'1');
 INSERT INTO `ezpolicy_limitation_value` VALUES (578,254,'1739204639');
 INSERT INTO `ezpolicy_limitation_value` VALUES (579,254,'3430272718');
 INSERT INTO `ezpolicy_limitation_value` VALUES (580,254,'2106599819');
-INSERT INTO `ezpolicy_limitation_value` VALUES (581,301,'1');
-INSERT INTO `ezpolicy_limitation_value` VALUES (582,302,'4');
-INSERT INTO `ezpolicy_limitation_value` VALUES (583,303,'4');
-INSERT INTO `ezpolicy_limitation_value` VALUES (584,304,'2');
 INSERT INTO `ezpolicy_limitation_value` VALUES (882,393,'16');
 INSERT INTO `ezpolicy_limitation_value` VALUES (883,393,'17');
 INSERT INTO `ezpolicy_limitation_value` VALUES (884,393,'26');