diff --git a/Resources/public/js/views/services/plugins/ez-userloadplugin.js b/Resources/public/js/views/services/plugins/ez-userloadplugin.js
index 4994035..33b9b0e 100644
--- a/Resources/public/js/views/services/plugins/ez-userloadplugin.js
+++ b/Resources/public/js/views/services/plugins/ez-userloadplugin.js
@@ -41,12 +41,13 @@ YUI.add('ez-userloadplugin', function (Y) {
             var loadOptions = {api: this.get('host').get('capi')},
                 User = this.get('userModelConstructor'),
                 loadedUser = new User(),
-                attribute = e.attributeName;
+                attribute = e.attributeName,
+                loadingErrorAttributeName = e.loadingErrorAttributeName || 'loadingError';
 
             loadedUser.set('id', e.userId);
             loadedUser.load(loadOptions, function(error) {
                 if (error) {
-                    e.target.set('loadingError', true);
+                    e.target.set(loadingErrorAttributeName, true);
                 } else {
                     e.target.set(attribute, loadedUser);
                 }
diff --git a/Resources/public/js/views/tabs/ez-locationviewdetailstabview.js b/Resources/public/js/views/tabs/ez-locationviewdetailstabview.js
index a561f61..a8ad7ae 100644
--- a/Resources/public/js/views/tabs/ez-locationviewdetailstabview.js
+++ b/Resources/public/js/views/tabs/ez-locationviewdetailstabview.js
@@ -48,7 +48,7 @@ YUI.add('ez-locationviewdetailstabview', function (Y) {
                 this._fireLoadUser();
             };
 
-            this.after(['creatorChange', 'ownerChange', 'sectionChange'], function (e) {
+            this.after(['creatorChange', 'creatorLoadingErrorChange', 'ownerChange', 'ownerLoadingErrorChange', 'sectionChange'], function (e) {
                 this.render();
             });
             this._addDOMEventHandlers(events);
@@ -88,7 +88,8 @@ YUI.add('ez-locationviewdetailstabview', function (Y) {
                 "contentCreator": owner,
                 "translationsList": translationsList,
                 "languageCount": translationsList.length,
-                "loadingError": this.get('loadingError'),
+                "lastContributorLoadingError": this.get('creatorLoadingError'),
+                "contentCreatorLoadingError": this.get('ownerLoadingError'),
                 "sortFields": this._getSortFields(),
                 "isAscendingOrder": (this.get('sortOrder') === 'ASC'),
                 "section": section,
@@ -178,16 +179,21 @@ YUI.add('ez-locationviewdetailstabview', function (Y) {
             this.fire('loadUser', {
                 userId: creatorId,
                 attributeName: 'creator',
+                loadingErrorAttributeName: 'creatorLoadingError'
             });
 
             if (creatorId === ownerId) {
                 this.onceAfter('creatorChange', function (e) {
                     this.set('owner', this.get('creator'));
                 });
+                this.onceAfter('creatorLoadingErrorChange', function (e) {
+                    this.set('ownerLoadingError', this.get('creatorLoadingError'));
+                });
             } else {
                 this.fire('loadUser', {
                     userId: ownerId,
                     attributeName: 'owner',
+                    loadingErrorAttributeName: 'ownerLoadingError'
                 });
             }
         },
@@ -254,6 +260,16 @@ YUI.add('ez-locationviewdetailstabview', function (Y) {
             creator: {},
 
             /**
+             * Indicates error while loading creator of the content
+             *
+             * @attribute creatorLoadingError
+             * @type {Boolean}
+             */
+            creatorLoadingError: {
+                value: false
+            },
+
+            /**
              * The owner of the content
              *
              * @attribute owner
@@ -262,6 +278,16 @@ YUI.add('ez-locationviewdetailstabview', function (Y) {
             owner: {},
 
             /**
+             * Indicates error while loading owner of the content
+             *
+             * @attribute ownerLoadingError
+             * @type {Boolean}
+             */
+            ownerLoadingError: {
+                value: false
+            },
+
+            /**
              * The content being displayed
              *
              * @attribute content
diff --git a/Resources/public/templates/tabs/details.hbt b/Resources/public/templates/tabs/details.hbt
index b70ab60..73b1ff4 100644
--- a/Resources/public/templates/tabs/details.hbt
+++ b/Resources/public/templates/tabs/details.hbt
@@ -6,7 +6,7 @@
     <dl class="ez-details-box-list ez-details-authors ez-asynchronousview pure-g"">
         <dt class="ez-details-name pure-u-1-3">{{ translate 'locationview.details.creator' 'locationview'}}</dt>
         <dd class="ez-details-value pure-u-2-3">
-        {{#if loadingError}}
+        {{#if contentCreatorLoadingError}}
             <p class="ez-asynchronousview-error ez-font-icon">
                 {{ translate 'locationview.details.errorcreator' 'locationview'}}
                 <button class="ez-asynchronousview-retry ez-button ez-font-icon pure-button">
@@ -24,7 +24,7 @@
 
         <dt class="ez-details-name pure-u-1-3">{{ translate 'locationview.details.lastcontributor' 'locationview' }}</dt>
         <dd class="ez-details-value pure-u-2-3">
-        {{#if loadingError}}
+        {{#if lastContributorLoadingError}}
             <p class="ez-asynchronousview-error ez-font-icon">
                 {{ translate 'locationview.details.errorcontributor' 'locationview'}}
                 <button class="ez-asynchronousview-retry ez-button ez-font-icon pure-button">