diff --git a/src/bundle/DependencyInjection/Configuration/Parser/PageBuilder.php b/src/bundle/DependencyInjection/Configuration/Parser/PageBuilder.php
index 88de3880..1b73a083 100644
--- a/src/bundle/DependencyInjection/Configuration/Parser/PageBuilder.php
+++ b/src/bundle/DependencyInjection/Configuration/Parser/PageBuilder.php
@@ -22,6 +22,9 @@
  *      default: # configuration per siteaccess or siteaccess group
  *          page_builder:
  *              siteaccess_list: [site, de, fr, no]
+ *              siteaccess_hosts:
+ *                  - some.site.com
+ *                  - another.some.site.com
  *              inject_cross_origin_helper: true
  * ```
  */
@@ -43,6 +46,11 @@ public function addSemanticConfig(NodeBuilder $nodeBuilder)
                         ->info('List of siteaccesses available for content preview in Page Builder.')
                         ->defaultValue([])
                     ->end()
+                    ->arrayNode('siteaccess_hosts')
+                        ->scalarPrototype()->end()
+                        ->info('List of siteaccesses hosts for content preview in Page Builder.')
+                        ->defaultValue([])
+                    ->end()
                     ->booleanNode('inject_cross_origin_helper')
                         ->defaultTrue()
                     ->end()
@@ -70,6 +78,14 @@ public function mapConfig(array &$scopeSettings, $currentScope, ContextualizerIn
             );
         }

+        if (!empty($settings['siteaccess_hosts'])) {
+            $contextualizer->setContextualParameter(
+                'page_builder.siteaccess_hosts',
+                $currentScope,
+                $settings['siteaccess_hosts']
+            );
+        }
+
         if (!empty($settings['inject_cross_origin_helper'])) {
             $contextualizer->setContextualParameter(
                 'page_builder.inject_cross_origin_helper',
diff --git a/src/bundle/Resources/config/ezplatform_default_settings.yml b/src/bundle/Resources/config/ezplatform_default_settings.yml
index 9a0a90aa..36573c37 100644
--- a/src/bundle/Resources/config/ezplatform_default_settings.yml
+++ b/src/bundle/Resources/config/ezplatform_default_settings.yml
@@ -7,3 +7,6 @@ parameters:

     # Cross Origin Helper
     ezsettings.default.page_builder.inject_cross_origin_helper: true
+
+    # Siteaccesses allowed hosts for PageBuilder
+    ezsettings.default.page_builder.siteaccess_hosts: []
diff --git a/src/lib/Event/Subscriber/InjectCrossOriginHelperSubscriber.php b/src/lib/Event/Subscriber/InjectCrossOriginHelperSubscriber.php
index b995a8ad..12479ca4 100644
--- a/src/lib/Event/Subscriber/InjectCrossOriginHelperSubscriber.php
+++ b/src/lib/Event/Subscriber/InjectCrossOriginHelperSubscriber.php
@@ -13,6 +13,7 @@
 use EzSystems\EzPlatformPageBuilder\PageBuilder\ConfigurationResolverInterface;
 use EzSystems\EzPlatformPageBuilder\Siteaccess\ReverseMatcher;
 use Symfony\Component\EventDispatcher\EventSubscriberInterface;
+use Symfony\Component\HttpFoundation\Request;
 use Symfony\Component\HttpFoundation\Response;
 use Symfony\Component\HttpKernel\Event\FilterResponseEvent;
 use Symfony\Component\HttpKernel\KernelEvents;
@@ -106,6 +107,10 @@ public function onResponse(FilterResponseEvent $event)
             return;
         }

+        if (true === $this->injectSnippetForSiteaccessHosts($request, $response)) {
+            return;
+        }
+
         $hosts = $this->getCompatibleHosts($this->siteaccess->name);
         $host = reset($hosts);

@@ -138,6 +143,32 @@ private function getCompatibleHosts(string $requestSiteaccessName): array
         return array_unique($hosts);
     }

+    private function injectSnippetForSiteaccessHosts(
+        Request $request,
+        Response $response
+    ): bool {
+        $siteAccessHosts = $this->pageBuilderConfigResolver->getSiteaccessHosts(
+            $this->siteaccess->name
+        );
+
+        if (empty($siteAccessHosts)) {
+            return false;
+        }
+
+        $scheme = $request->getScheme();
+        $port = $request->getPort();
+        $portPart = in_array($port, [80, 443]) ? '' : ":{$port}";
+        $siteAccessUrls = [];
+
+        foreach ($siteAccessHosts as $host) {
+            $siteAccessUrls[] = $scheme . '://' . $host . $portPart;
+        }
+
+        $this->injectSnippet($response, $siteAccessUrls);
+
+        return true;
+    }
+
     /**
      * @param \Symfony\Component\HttpFoundation\Response $response
      * @param string[] $hosts
diff --git a/src/lib/PageBuilder/ConfigurationResolver.php b/src/lib/PageBuilder/ConfigurationResolver.php
index bb7dd585..7e2bbc66 100644
--- a/src/lib/PageBuilder/ConfigurationResolver.php
+++ b/src/lib/PageBuilder/ConfigurationResolver.php
@@ -54,6 +54,23 @@ public function getSiteaccessList(string $siteaccess = null): array
         return array_intersect($this->siteAccesses, $pageBuilderSiteaccesses);
     }

+    public function getSiteaccessHosts(string $siteaccessName): array
+    {
+        $compatibleAdminSiteaccesses = $this->reverseAdminSiteaccessMatch(
+            $siteaccessName
+        );
+
+        $siteAccessHosts = [];
+        foreach ($compatibleAdminSiteaccesses as $adminSiteaccess) {
+            $siteAccessHosts = array_merge(
+                $siteAccessHosts,
+                $this->get('siteaccess_hosts', $adminSiteaccess)
+            );
+        }
+
+        return array_values(array_unique($siteAccessHosts));
+    }
+
     /**
      * @param string $name
      * @param string|null $siteaccess
diff --git a/src/lib/PageBuilder/ConfigurationResolverInterface.php b/src/lib/PageBuilder/ConfigurationResolverInterface.php
index 87c313de..eb9a1be6 100644
--- a/src/lib/PageBuilder/ConfigurationResolverInterface.php
+++ b/src/lib/PageBuilder/ConfigurationResolverInterface.php
@@ -26,6 +26,13 @@ public function reverseAdminSiteaccessMatch(string $siteaccessName): array;
      */
     public function getSiteaccessList(string $siteaccess = null): array;

+    /**
+     * @param string $siteaccessName
+     *
+     * @return string[]
+     */
+    public function getSiteaccessHosts(string $siteaccessName): array;
+
     /**
      * @param string $name
      * @param string|null $siteaccess
diff --git a/src/lib/PageBuilder/PermissionAwareConfigurationResolver.php b/src/lib/PageBuilder/PermissionAwareConfigurationResolver.php
index 18ed281e..95a41737 100644
--- a/src/lib/PageBuilder/PermissionAwareConfigurationResolver.php
+++ b/src/lib/PageBuilder/PermissionAwareConfigurationResolver.php
@@ -46,6 +46,11 @@ public function getSiteaccessList(string $siteaccess = null): array
         return $this->siteaccessService->filterAvailableSiteaccesses($siteaccesses);
     }

+    public function getSiteaccessHosts(string $siteaccessName): array
+    {
+        return $this->getSiteaccessHosts($siteaccessName);
+    }
+
     /**
      * @param string $name
      * @param string|null $siteaccess